#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Compression=4
#EndRegion 

#Region #### AutoIt Includes ####
#include <Array.au3>
#include <Clipboard.au3>
#include <ColorConstants.au3>
;~ #include 'Datenaufnahme.au3'
#Include <File.au3>
;~ #include '_FileCopyEx.au3'
#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <GUIconstants.au3>
#include <Misc.au3>
#include <MsgBoxConstants.au3>
#include <Process.au3>
#include <ScreenCapture.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#EndRegion #### AutoIt Includes ####

#Region ### Optionen Section ###
Opt('GUIOnEventMode', 0) ; 1 Schaltet den OnEvent-Mode ein
;~ Opt('MustDeclareVars', 1) ; Variablen müssen vor der Benutzung deklariert werden
Opt('TrayAutoPause', 0) ; das Script nicht pausieren, wenn auf das Tray-Icon geklickt wird
Opt('GUICloseOnESC', 0) ; das drücken der ESC-Taste führt nicht zum beenden des Programms
Opt('TrayMenuMode', 1) ; 1 = kein Standard Menü erstellen
#EndRegion ### Optionen Section ###

SplashOff()

Global $sTitle = ' myBackup - '
Global $sVersion = '1.0.3.9'
Global $sDate = '28.08.2017'
 
Global $hGui = GUICreate(StringFormat('%s v%3.5s', $sTitle, $sVersion), 302,300,-1,300) ; Fenster erstellen
GUISetIcon('shell32.dll', 32) ; Icon für das Fenster festlegen
;~ GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseGui') ; Funktion die beim schließen des Fensters aufgerufen wird
WinSetOnTop($sTitle, '', 1) ; 1 = den Wert für "Immer im Vordergrund" setzen

Global $i_FontSize = 9
Global $i_FontWeight = 800
Global $s_FontName = 'Lucida Console'
GUISetBkColor(0xFFFABB)

Global $ini = @ScriptDir & "\myBackup.ini" ; Path & Name to Inifile

$Label_1=GuiCtrlCreateLabel("Status:",26,10,50,15)
$Label_2=GuiCtrlCreateLabel("Kein USB-Medium gefunden!",70,10,200,15)
         GuiCtrlSetFont($Label_2,$i_FontSize,$i_FontWeight)
         GUICtrlSetColor($Label_2, $COLOR_RED)
$Label_3=GuiCtrlCreateLabel("Größe der zu sichernden Daten:" ,26,30,270,15)
$Label_4=GuiCtrlCreateLabel("",197,30,75,15,0x2) ; 0x2 mittig
         GuiCtrlSetFont($Label_4,$i_FontSize,$i_FontWeight)
         GUICtrlSetColor($Label_4, $COLOR_RED)
		GUICtrlCreateGroup("", 10, 55, 281, 65)  ; Umrandung Outlook             
;~ $Label_5=GuiCtrlCreateLabel("",26,55,0,15)  
$Label_5=GuiCtrlCreateLabel("Sicherung",26,55,52,15)  
Global $Outlook = GUICtrlCreateCheckbox("Outlook - Persönliche Ordner", 26, 73, 200, 20)
GUICtrlSetState(-1, 0) ; unchecked
Global $hddd = GUICtrlCreateCheckbox("Festplatte - D:", 26, 93, 200, 20)
GUICtrlSetState(-1, 0) ; unchecked

         GUICtrlCreateGroup("  Ziellaufwerk wählen                                 Freier Platz", 10, 130, 281, 90) ; Umrandung Ziellaufwerk
$Label_6=GuiCtrlCreateLabel("Ziellaufwerk = ",26,195,120,15)  
         GuiCtrlSetFont($Label_6,$i_FontSize,$i_FontWeight)
$Label_7=GuiCtrlCreateLabel("",110,195,200,15)  
         GuiCtrlSetFont($Label_7,$i_FontSize,$i_FontWeight)

$btnBackup = GUICtrlCreateButton("  Backup  ", 26, 250) 	; Create a button to start the backup process
$btnIni = GUICtrlCreateButton("  Edit ini...  ", 120, 250) 	; Create a button to start the backup process
$btnRestore = GUICtrlCreateButton("  Restore  ", 215, 250); Create a button to start the backup process

#Region ### ini_read ####
If Not FileExists(@ScriptDir & "\myBackup.ini") Then
              
            _ini_create()

EndIf
 
Global $q_Array = IniReadSection($ini, "Quellen")
Global $z_Array = IniReadSection($ini, "Ziel")
Global $Backup_Ziel_Verzeichnis = ($z_Array[1][1])

              local $tmp = 0
              For $i = 1 To $q_Array[0][0]
 
                $array_Quelle = ($q_Array[$i][1])
                $Quell_Verzeichnis = StringReplace($array_Quelle, "*Userprofil*", @UserProfileDir)
                $Quell_Laufwerk = StringLeft($Quell_Verzeichnis,3)
                $Quell_Buchstabe = StringLeft($Quell_Verzeichnis,1)                          
                Local $Ordner = DirGetSize($q_Array[$i][1])                                                                                                                                                      
                DirGetSize($Quell_Verzeichnis)
                $tmp +=($Ordner) ;Größe zusammenrechnen

                Next

				global $PstFiles = iniread($ini, "outlook", "size", "default") ;; Pst Dateien vorhanden?
				if iniread($ini, "Outlook", "Size", "default") Then
				GUICtrlSetState($Outlook, $GUI_checked)
				Else
				GUICtrlSetState($Outlook, $GUI_DISABLE)
				endif
				
				global $hdd_d = iniread($ini, "hdd_d", "size", "default") ;; HDD-D vorhanden
				if iniread($ini, "hdd_d", "size", "default") Then
				GUICtrlSetState($hddd, $GUI_checked)
				Else
				GUICtrlSetState($hddd, $GUI_DISABLE)
				EndIf

				GUICtrlSetData($Label_3,"Größe der zu sichernden Daten:")
				$gesammt = GUICtrlSetData($Label_4, round(($PstFiles + $hdd_d + $tmp /1024 /1024), 0) & " MB")
;~ 				EndIf
		
				
#EndRegion ### ini_read ####

GUISetState(@SW_SHOW, $hGui) ; Show GUI


_USB_Medium() ;Ist ein USB-Medium angeschlossen?


#Region ### ini_Info ####

;~ 	Local $sMsg = 'Um Backups erstellen zu können, wurde eine Standard ini (myBackup.ini) erstellt.\n\n'
;~ 	$sMsg &= 'Die sicherung umfasst folgende Ordner in Ihrem Profil:\n\n\t'
;~ 	$sMsg &= '- Bilder\n\t'
;~ 	$sMsg &= '- Downloads\n\t'
;~ 	$sMsg &= '- Documentum\n\t'
;~ 	$sMsg &= '- Eigene Dateien\n\t'
;~ 	$sMsg &= '- Internet Explorer Favoriten\n\t'
;~ 	$sMsg &= '- Links\n\t'
;~ 	$sMsg &= '- Musik\n\t'
;~ 	$sMsg &= '- Videos\n\t'
;~ 	$sMsg &= '- AppData (für weitere Informationen bitte ini öffnen)\n\n'
;~ 	$sMsg &= '\nDie ini-Datei kann im Bereich ""Ihre Einstellungen"" erweitert werden.\n'
;~ 	MsgBox(0, $sTitle & 'ini nicht gefunden!', StringFormat($sMsg), 0, $hGui)
	
GUICreate("Ini-Datei nicht gefunden...", 500, 300) ; will create a dialog box that when displayed is centered
Local $idMyedit = GUICtrlCreateEdit("",10, 10, 480, 250, $ES_READONLY)
GUISetState(@SW_SHOW)
GUICtrlSetData(-1, StringFormat("Um Backups erstellen zu können, wurde eine Standard ini (myBackup.ini) erstellt.\r\n\r\nDie Sicherung umfasst nur die Daten des aktuell angemeldeten Benutzers:\r\n\r\n"  & _
								"\r	- Bilder\r\n	- Downloads\r\n	- Documentum\r\n	- Eigene Dateien\r\n	- Fierfox Profil\r\n	- Internet Explorer Favoriten\r\n	- Links\r\n	- Musik\r\n	- Videos\r\n" & _
								"\r	- AppData (für weitere Informationen bitte ini öffnen)\r\n\r\nDie Datei kann ab Punkt 50. ihrerseits erweitert werden.\r\n"))
GUISetBkColor(0xFFFABB) ;; 0xFFFFFF)
GUICtrlSetColor(-1, 0x000000)
GUICtrlSetFont(-1, 9, 800, 0, "Arial")

	$btnOK = GUICtrlCreateButton("  OK  ", 235, 270, 50, 25); Create a button to start the backup process

	While 1
		Switch GUIGetMsg()
			
			Case $GUI_EVENT_CLOSE
				ExitLoop
				
			Case $btnOK
				ExitLoop
		EndSwitch
	WEnd
	GUIDelete()

;~ EndFunc   ;==>create_ini
#EndRegion ### ini_Info ####


func _USB_Medium()
              
Global $drives=DriveGetDrive("removable")
 
If @error Then
    Sleep(2000)
    MsgBox(16,"Kein USB-Stick gefunden!","Kein USB-Stick gefunden!" & @cr &  @cr & "Bitte schliessen Sie einen USB-Stick an!" & @cr & @cr & "Die Anwendung wird beendet.",20000)              
EndIf
 
dim $name[$drives[0]+1]
dim $space[$drives[0]+1]
$maxname=2
$maxspace=0
for $i=1 to $drives[0]
  $name[$i]=StringLen(DriveGetLabel($drives[$i]))
  if $name[$i]>=$maxname then
    $maxname=$name[$i]
  endif
  $space[$i]=StringLen(Round(DriveSpaceFree($drives[$i])))
  if $space[$i]>=$maxspace then
    $maxspace=$space[$i]
  endif
Next
 
 
$width=($maxname+$maxspace)+8+150
if $width<210 then $width=300              
              
GUISetFont($i_FontSize,$i_FontWeight) ;;Set general window font
For $i=1 to $drives[0]
  If $i=0 Then 
    GUICtrlSetData($Label_2,"Kein USB Medium angeschloßen!")
    Sleep(5000)
    MsgBox(16,"Kein USB-Medium gefunden!","Kein USB-Medium gefunden!" & @CR & "Die Anwendung wird jetzt beendet." & @cr & $Label_3 & " " & $Label_4,30000)      
    Exit
  Else
    If $i=NOT 0 Then        
      GUICtrlSetData($Label_2,"USB-Medium gefunden...") ;;report drives found     
    EndIf 
  EndIf
Next
              
              
dim $chkboxes[$drives[0] + 1]
$chkboxes[0]=$drives[0]
$Ypos=145
for $i=1 to $drives[0]
  $chkboxes[$i]=GUICtrlCreateRadio(StringUpper($drives[$i]), 26,$Ypos,35,20) ;; & " (" & DriveGetLabel($drives[$i]) & ")"),26,$Ypos,($maxname+5)*8,20)
  GuiCtrlSetState(-1,$GUI_UNCHECKED)
  $Ypos=$Ypos+20
next
$Ypos=145
for $i=1 to $drives[0]
  $FreeMem=GuiCtrlCreateLabel(Round(DriveSpaceFree($drives[$i])) & " MB",198,$Ypos,75,15,0x2)
  GuiCtrlSetFont($FreeMem, $i_FontSize, $i_FontWeight)
  $Ypos=$Ypos+20
next 

While 1
$nMsg = GUIGetMsg()
Switch $nMsg
Case -3
Exit

#Region ### addieren - subtrahieren ####

Case $Outlook 
	
	$OutlookBox = GUICtrlRead($Outlook)
	$hdddBox = GUICtrlRead($hddd)

If (BitAND($OutlookBox, $GUI_CHECKED) = $GUI_CHECKED) Then
				$gesammt = GUICtrlSetData($Label_4, round(($PstFiles + $tmp /1024 /1024), 0) & " MB")	

ElseIf (BitAND($OutlookBox, $GUI_CHECKED) = $GUI_CHECKED) and (BitAND($hdddBox, $GUI_CHECKED) = $GUI_CHECKED)  Then
				$gesammt = GUICtrlSetData($Label_4, round(($PstFiles + $hdd_d + $tmp /1024 /1024), 0) & " MB")	
ElseIf (BitAND($OutlookBox, $GUI_UNCHECKED) = $GUI_UNCHECKED) Then
				$gesammt = GUICtrlSetData($Label_4, round(($tmp /1024 /1024), 0) & " MB")					
EndIf
	
	;~ 				If GUICtrlRead($Outlook) = 4 Then
;~ 				$gesammt = GUICtrlSetData($Label_4, round(($tmp /1024 /1024), 0) & " MB")
;~ 				elseif GUICtrlRead($Outlook) = 1 Then
;~ 				$gesammt = GUICtrlSetData($Label_4, round(($PstFiles + $tmp /1024 /1024), 0) & " MB")
;~ 				Elseif GUICtrlRead($Outlook) = 1 & GUICtrlRead($hddd) = 1 Then
;~ 				$gesammt = GUICtrlSetData($Label_4, round(($PstFiles + $hdd_d + $tmp /1024 /1024), 0) & " MB")
;~ 				EndIf
								
Case $hddd 
				If GUICtrlRead($hddd) = 4 Then
				$gesammt = GUICtrlSetData($Label_4, round(($tmp /1024 /1024), 0) & " MB")
				Elseif GUICtrlRead($hddd) = 1 Then
				$gesammt = GUICtrlSetData($Label_4, round(($hdd_d + $tmp /1024 /1024), 0) & " MB")
				Elseif GUICtrlRead($hddd) = 1 & GUICtrlRead($Outlook) = 1 Then
				$gesammt = GUICtrlSetData($Label_4, round(($hdd_d + $PstFiles + $tmp /1024 /1024), 0) & " MB")
				EndIf
				
#EndRegion ### addieren - subtrahieren ####


Case $btnIni 
		_edit_ini()
 
Case $btnBackup; If backup button is pressed.

	$Ziel = iniread($ini, "Ziel", "1", "default") ;; 
	if iniread($ini, "Ziel", "1", "default") Then

        _Backup() ; Start backup
					
	else 
		
MsgBox(262208,"Kein Ziellaufwerk... ","Bitte wählen Sie zuerst ein Ziellaufwerk aus." & @CRLF & "Und starten die Sicherung erneut." & @CRLF & "" & @CRLF & "",0)

	EndIf

Case $btnRestore; If backup button is pressed.

Case Else
Local $sCheckedDrives = ''
Local $iIndex = _ArraySearch($chkboxes, $nMsg)
If $iIndex <> -1 Then
    $sCheckedDrives = ControlGetText("", '', $chkboxes[$iIndex]) & ''
    Local $sFilePath = ($ini)
    IniWriteSection($sFilePath, "Ziel", "1=" & $sCheckedDrives & "$Backup$" & "\")
    Local $aArray = IniReadSection($sFilePath, "Ziel")
    $ZPfad = GUICtrlSetData($Label_7, $sCheckedDrives & "$Backup$")

;~     If Not @error Then
;~     ShellExecute("myBackup.ini")
;~     EndIf
EndIf
EndSwitch
WEnd
 
EndFunc  ;Ende - USB-Medium angeschlossen?

Func _edit_ini()
	
	If Not FileExists($ini) Then    
            _ini_create()
		ShellExecute("myBackup.ini")
	
		Else
		ShellExecute("myBackup.ini")
	EndIf
EndFunc


Func _Backup()
			
			$Ziellaufwerk = iniread($ini, "Ziel", "1", "default") ;; 
    
			For $i = 1 To $q_Array[0][0]
            $array_Quelle = ($q_Array[$i][1])
            $Quell_Verzeichnis = StringReplace($array_Quelle, "*Userprofil*", @UserProfileDir)
            $Quell_Laufwerk = StringLeft($Quell_Verzeichnis,3)
            $Quell_Buchstabe = StringLeft($Quell_Verzeichnis,1)
 
            $Backup_Ziel = StringReplace("Drive_" & $Quell_Verzeichnis, ":", "")
            $Backup_Ziel_Pfad = ( $Backup_Ziel_Verzeichnis  & $Backup_Ziel)

			$Ziel = ($Ziellaufwerk & $Backup_Ziel_Pfad)

;~             $Ziel = StringReplace($Backup_Ziel_Pfad, "*Userprofil*", $Ziellaufwerk)   
;~             $Ziel = StringReplace($Backup_Ziel_Pfad, "*Userprofil*", @UserProfileDir)                                                                                                         
            Sleep(1000)

            Global $sSourceDir = $Quell_Verzeichnis ; alle Dateien aus diesem Verzeichnis sollen kopiert werden
            Global $sDestDir = $Ziel ; die Quelldateien sollen (mit Unterverzeichnissen) in dieses Verzeichnis kopiert werden

            Global $aSourceFiles[1], $aDestDir[1]
              
            _FileCopyEx_CreateArrays($sSourceDir, $sDestDir, $aSourceFiles, $aDestDir, '*') ; diese Funktion erstellt die Arrays für _FileCopyEx
            If Not @error Then
            Global $sLog = _FileCopyEx($aSourceFiles, $aDestDir, 16 + 8 + 2 + 1, 'Dateien kopieren...') ; hier erfolgt dann das kopieren
            ConsoleWrite('Fehler: ' & @error & @CR)
            ConsoleWrite($sLog & @CR)
            EndIf                                              
            Next     

    

			If Not FileExists($Backup_Ziel_Verzeichnis & "UserProfileDir.txt") Then
				FileWrite($Backup_Ziel_Verzeichnis & "UserProfileDir.txt",@UserProfileDir)
			EndIf
                                              
EndFunc   ;==>_Backup

Func _IsChecked($idControlID)
    Return BitAND(GUICtrlRead($idControlID), $GUI_CHECKED) = $GUI_CHECKED
EndFunc   ;==>_IsChecked
